<html>
<head>
<title>OgreD3D11Prerequisites.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11Prerequisites.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11Prerequisites_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11PREREQUISITES_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11PREREQUISITES_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMinGWSupport_8h.html">WIN32/OgreMinGWSupport.h</a>&quot;</span> <span class="comment">// extra defines for MinGW to deal with DX SDK</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_RECURSIVE_MUTEX(name)   name.lock();</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#define OGRE_UNLOCK_RECURSIVE_MUTEX(name) name.unlock();</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00038"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#ab1fd107573047bd9da140ea653623f32">00038</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_RECURSIVE_MUTEX(name) </span>
<a name="l00039"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a93ac575df386b84b1954cb49c5d5602b">00039</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_UNLOCK_RECURSIVE_MUTEX(name)</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="preprocessor">#if OGRE_THREAD_SUPPORT == 1</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#define D3D11_DEVICE_ACCESS_LOCK                OGRE_LOCK_RECURSIVE_MUTEX(msDeviceAccessMutex);</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#define D3D11_DEVICE_ACCESS_UNLOCK          OGRE_UNLOCK_RECURSIVE_MUTEX(msDeviceAccessMutex);</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#define D3D11_DEVICE_ACCESS_CRITICAL_SECTION    OGRE_LOCK_MUTEX(msDeviceAccessMutex)</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00048"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a91eca3b862fb87e1aae6365506aaef7e">00048</a> <span class="preprocessor"></span><span class="preprocessor">#define D3D11_DEVICE_ACCESS_LOCK    </span>
<a name="l00049"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a7e62356528bac65b4d973f3b6cf5248f">00049</a> <span class="preprocessor"></span><span class="preprocessor">#define D3D11_DEVICE_ACCESS_UNLOCK</span>
<a name="l00050"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a756e79282d7620576504b98f89317361">00050</a> <span class="preprocessor"></span><span class="preprocessor">#define D3D11_DEVICE_ACCESS_CRITICAL_SECTION</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 <span class="comment">// Define versions for if DirectX is in use (Win32 only)</span>
<a name="l00054"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#aa54da3d73d29cce6595914535d88a09a">00054</a> <span class="preprocessor">#define DIRECT3D_VERSION 0x1100</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 <span class="comment">// some D3D commonly used macros</span>
<a name="l00057"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a9bbcd82e77c41df827c09759def05c9a">00057</a> <span class="preprocessor">#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }</span>
<a name="l00058"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a506b3685b3eb05aac751f9e14cbed93b">00058</a> <span class="preprocessor"></span><span class="preprocessor">#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }</span>
<a name="l00059"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a6038f7bdb274c2e159988a57dedbf93d">00059</a> <span class="preprocessor"></span><span class="preprocessor">#define SAFE_RELEASE(p)      { if(p) { (p)-&gt;Release(); (p)=NULL; } }</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="preprocessor">#undef NOMINMAX</span>
<a name="l00063"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a9f918755b601cf4bffca775992e6fb90">00063</a> <span class="preprocessor"></span><span class="preprocessor">#define NOMINMAX // required to stop windows.h screwing up std::min definition</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#include &lt;d3d11.h&gt;</span>
<a name="l00065"></a>00065 <span class="preprocessor">#include &lt;d3dx11.h&gt;</span>
<a name="l00066"></a>00066 <span class="preprocessor">#include &lt;d3d11shader.h&gt;</span>
<a name="l00067"></a>00067 <span class="preprocessor">#include &lt;D3Dcompiler.h&gt;</span>
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="keyword">namespace </span>Ogre
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072     <span class="comment">// Predefine classes</span>
<a name="l00073"></a>00073     <span class="keyword">class </span>D3D11RenderSystem;
<a name="l00074"></a>00074     <span class="keyword">class </span>D3D11RenderWindow;
<a name="l00075"></a>00075     <span class="keyword">class </span>D3D11Texture;
<a name="l00076"></a>00076     <span class="keyword">class </span>D3D11TextureManager;
<a name="l00077"></a>00077     <span class="keyword">class </span>D3D11DepthBuffer;
<a name="l00078"></a>00078     <span class="keyword">class </span>D3D11Driver;
<a name="l00079"></a>00079     <span class="keyword">class </span>D3D11DriverList;
<a name="l00080"></a>00080     <span class="keyword">class </span>D3D11VideoMode;
<a name="l00081"></a>00081     <span class="keyword">class </span>D3D11VideoModeList;
<a name="l00082"></a>00082     <span class="keyword">class </span>D3D11GpuProgram;
<a name="l00083"></a>00083     <span class="keyword">class </span>D3D11GpuProgramManager;
<a name="l00084"></a>00084     <span class="keyword">class </span>D3D11HardwareBufferManager;
<a name="l00085"></a>00085     <span class="keyword">class </span>D3D11HardwareIndexBuffer;
<a name="l00086"></a>00086     <span class="keyword">class </span>D3D11HLSLProgramFactory;
<a name="l00087"></a>00087     <span class="keyword">class </span>D3D11HLSLProgram;
<a name="l00088"></a>00088     <span class="keyword">class </span>D3D11VertexDeclaration;
<a name="l00089"></a>00089     <span class="keyword">class </span>D3D11Device;
<a name="l00090"></a>00090     <span class="keyword">class </span>D3D11HardwareBuffer;
<a name="l00091"></a>00091     <span class="keyword">class </span>D3D11HardwarePixelBuffer;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="comment">// Should we ask D3D to manage vertex/index buffers automatically?</span>
<a name="l00094"></a>00094     <span class="comment">// Doing so avoids lost devices, but also has a performance impact</span>
<a name="l00095"></a>00095     <span class="comment">// which is unacceptably bad when using very large buffers</span>
<a name="l00096"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#a7b3123eeef6059cf58d74050e93fbf96">00096</a> <span class="preprocessor">#define OGRE_D3D_MANAGE_BUFFERS 1</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>
<a name="l00098"></a>00098     <span class="comment">//-------------------------------------------</span>
<a name="l00099"></a>00099     <span class="comment">// Windows setttings</span>
<a name="l00100"></a>00100     <span class="comment">//-------------------------------------------</span>
<a name="l00101"></a>00101 <span class="preprocessor">#if (OGRE_PLATFORM == OGRE_PLATFORM_WIN32) &amp;&amp; !defined(OGRE_STATIC_LIB)</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span><span class="preprocessor">#   ifdef OGRED3DENGINEDLL_EXPORTS</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span><span class="preprocessor">#       define _OgreD3D11Export __declspec(dllexport)</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">#       if defined( __MINGW32__ )</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span><span class="preprocessor">#           define _OgreD3D11Export</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span><span class="preprocessor">#       else</span>
<a name="l00108"></a><a class="code" href="OgreD3D11Prerequisites_8h.html#aeec4314638b775952fc5fa9f2d9516d3">00108</a> <span class="preprocessor"></span><span class="preprocessor">#           define _OgreD3D11Export __declspec(dllimport)</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="preprocessor">#   define _OgreD3D11Export</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">#endif  // OGRE_WIN32</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>}
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
